/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Augmented-Reality UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2002-02-24, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  */
package jaugment2.UI.ARUI.jini;



/**
 * Title:        ARUI
 * Description: ServiceUI Factory to allow representatinos that are meant only for ARUI and similar UIs
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public interface ARUIWidgetFactory
{

  /**
   * Convenience constant to use in the toolkit  field of UIDescriptors that contain a JComponentFactory. The value of this constant is "jaugment2.UI.ARUI".
   */
  public static final String TOOLKIT = "jaugment2.UI.ARUI";

  /**
   * Convenience constant to use in the UIFactoryTypes  set in the attributes set of UIDescriptors that contain a JComponentFactory. The value of this constant is "jaugment2.UI.ARUI.jini.ARUIWidgetFactory".
   */
  public static final String TYPE_NAME = "jaugment2.UI.ARUI.jini.ARUIWidgetFactory";


  public abstract jaugment2.UI.ARUI.widgets.ARUIWidgetIF createARUIWidget(Object o);
}