/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Augmented-Reality UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2002-02-24, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * 0.0.2 (2002-03-01, Marcus Wolschon<Suran@gmx.net>)
  *       - added serialization/deserialization
  * 0.0.3 (2002-03-02, Marcus Wolschon<Suran@gmx.net>)
  *       - added getFreeARWindow  and getAnyARWindow
  * -------------------------------------------------------------------
  * TODO:
  *       - test  deserialization
  */
package jaugment2.UI.ARUI.widgets;


import java.awt.*;
import javax.swing.*;
   // project
import jaugment2.helpers.Logger;
import jaugment2.UI.ARUI.xml.*;
  // SAX
import org.xml.sax.*;

/**
 * Title:        ARUI
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public class ARButton extends JButton implements ARUIWidgetIF
{

 //---------------------------------- ARUIWidgetIF  ----------------------------------
 public ARWindow getFreeARWindow()
 {
  return null;
 }
 public ARWindow getAnyARWindow()
 {
  return null;
 }
 public IconSlot getFreeIconSlot()
 {
  return null;
 }
 public Block getFreeBlock()
 {
  return null;
 }

 //---------------------------------- ------------  ----------------------------------

  public ARButton()
  {
   setOpaque(false);
  }

 private static final int framewidth = 2;
 /**
  * size of the edges (hor and vert) for the edges
  */
 private static final int edgesize = 5;

 public void paint(java.awt.Graphics g)
 {
   try
     {
      int width = getWidth()-framewidth/2;
      int height = getHeight()-framewidth/2;
//      g.setColor(getBackground());
//      g.fillRect(getX(), getY(), getWidth(), getHeight());


      java.awt.Point p[] = new java.awt.Point[]
         {
          new java.awt.Point(edgesize+framewidth/2, framewidth/2),

          new java.awt.Point(width-edgesize, framewidth/2),
          new java.awt.Point(width, edgesize+framewidth/2),


          new java.awt.Point(width, height - edgesize),
          new java.awt.Point(width - edgesize, height),

          new java.awt.Point((framewidth/2) + edgesize, height),
          new java.awt.Point(framewidth/2, height - edgesize),

          new java.awt.Point(framewidth/2, (framewidth/2) + edgesize),
          new java.awt.Point((framewidth/2) + edgesize, framewidth/2),

          new java.awt.Point((framewidth/2) + edgesize + 5, framewidth/2)
         };
      GraphicHelper.drawSmoothPolyline(p, framewidth, GraphicHelper.getInnerBorderColor(), g);
      int textwidth  = g.getFontMetrics().charsWidth(getText().toCharArray(), 0, getText().length());
      g.drawString(getText(), (width-textwidth)/2, height/2);
     }
   catch(Exception e)
     {
      e.printStackTrace(Logger.err);
     }
 }



 //--------- externaline and internalize to/from XML------------


 private class MyChainedDocumentHandler extends ChainedDocumentHandler
 {
  public void endElement(String p0) throws SAXException
  {
   super.endElement(p0);
  }

  public void startElement(String p0, AttributeList p1) throws SAXException
  {
   if(!p0.equalsIgnoreCase("ARWindow"))
     throw new SAXException("expected: <ARWindow>, found: <"+p0+">");
   setLabel(p1.getValue("caption"));
   super.startElement(p0, p1);
  }
 }

 public void externalizeToXML(java.io.PrintWriter pw)
 {
  pw.print("<ARButton caption=\"");
  pw.print(getLabel());
  pw.println("\"/>");
 }

 public ChainedDocumentHandler internalizeFromXML()
 {
  this.removeAll();
  return new MyChainedDocumentHandler();
 }
}