package jaugment2.UI.ARUI.widgets;

/**
 * Title:        ARUI
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public class GraphicHelper
{

  public GraphicHelper()
  {
  }



  /**
   * color that is used to draw the outher border of the whole configuration
   */
  public static java.awt.Color getOutherBorderColor()
  {
   return  new java.awt.Color(120, 20, 20);
  }

  public static java.awt.Color getInnerBorderColor()
  {
   return  new java.awt.Color(200, 20, 20);
  }
  public static java.awt.Color getFillColor()
  {
   return  new java.awt.Color(50, 20, 20, 128);
  }

  public static java.awt.Color getSelectedOutherBorderColor()
  {
   return  new java.awt.Color(20, 20, 120);
  }
  public static java.awt.Color getSelectedInnerBorderColor()
  {
   return  new java.awt.Color(20, 20, 200/*, 128*/);
  }
  public static java.awt.Color getSelectedFillColor()
  {
   return  new java.awt.Color(20, 20, 50, 128);
  }


  private static java.awt.Color mixColor(java.awt.Color c, float part, int whole)
  {
   float t = (part/whole);
   return new java.awt.Color((int)(c.getRed()*t), (int)(c.getGreen()*t), (int)(c.getBlue()*t), (int)(255*t));
  }

  private static void drawCircle(java.awt.Point p, int width, java.awt.Color c, java.awt.Graphics g)
  {
   for(int i=width/2; i>-1; i--)
     {
      java.awt.Color c2 = mixColor(c, width/2-i, width/2);
      g.setColor(c2);
      g.fillOval(p.x-i, p.y-i, i*2, i*2);
     }
  }

  private static boolean drawLine(java.awt.Point p0, java.awt.Point p1, int width, java.awt.Color c, java.awt.Graphics g, boolean washor)
  {
   boolean ishor = Math.abs( p0.x-p1.x ) >= Math.abs( p0.y-p1.y );
   boolean isleft = p0.x<p1.x;

   if(ishor)
   for(int i=width/2; i>-1; i--)
     { // hor
      java.awt.Color c2 = mixColor(c, width/2-i, width/2);
      g.setColor(c2);
      g.drawLine(p0.x+(washor?0:i), p0.y+i, p1.x, p1.y+i);
      g.drawLine(p0.x-(washor?0:i), p0.y-i, p1.x, p1.y-i);
     }
   else
   for(int i=width/2; i>-1; i--)
     { // vert
      java.awt.Color c2 = mixColor(c, width/2-i, width/2);
      g.setColor(c2);
      g.drawLine(p0.x+i, p0.y-(washor?i:0), p1.x+i, p1.y);
      g.drawLine(p0.x-i, p0.y+(washor?i:0), p1.x-i, p1.y);
     }
   return ishor;
  }

  public static void fillSmoothPolyline(java.awt.Point p[], int width, java.awt.Color c, java.awt.Color fillcolor, java.awt.Graphics g)
  {
   int x[] = new int[p.length];
   int y[] = new int[p.length];
   for(int i=0; i<p.length; i++)
      {
       x[i] = p[i].x;
       y[i] = p[i].y;
      }
   g.setColor(fillcolor);
   g.fillPolygon(x,y,p.length);
   drawSmoothPolyline(p, width, c, g);
  }

  public static void drawSmoothPolyline(java.awt.Point p[], int width, java.awt.Color c, java.awt.Graphics g)
  {
   for(int i=0; i<p.length; i++)
     drawCircle(p[i], width, c, g);
   boolean helper = false;
   for(int i=0; i<p.length-1; i++)
     {
      helper = drawLine(p[i], p[i+1], width, c, g, helper);
     }
  }

}