/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Augmented-Reality UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2002-02-18, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * 0.0.2 (2002-02-21, Marcus Wolschon<Suran@gmx.net>)
  *       - supports IconWidget
  *       - now 16px size instead of 8
  * 0.0.3 (2002-03-01, Marcus Wolschon<Suran@gmx.net>)
  *       - added serialization/deserialization
  * 0.0.4 (2002-03-02, Marcus Wolschon<Suran@gmx.net>)
  *       - added getFreeARWindow  and getAnyARWindow
  * 0.0.5 (2002-03-03, Marcus Wolschon<Suran@gmx.net>)
  *       - tested internalizing and externalizing
  * -------------------------------------------------------------------
  * TODO:
  */
package jaugment2.UI.ARUI.widgets;

import javax.swing.JPanel;
   // project
import jaugment2.helpers.Logger;
import jaugment2.UI.ARUI.xml.*;
  // SAX
import org.xml.sax.*;


/**
 * Title:        ARUI
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public class IconSlot extends JPanel implements ARUIWidgetIF
{
 private static final int framewidth = 2;
 public  static final int iconheight = 16;//8;
 public  static final int iconslotheight = iconheight+2*framewidth;
 public  static final java.awt.Color bordercolor =  GraphicHelper.getInnerBorderColor(); //new java.awt.Color(200, 20, 20);

  public IconSlot()
  {
   setMinimumSize(new java.awt.Dimension(iconslotheight, iconslotheight));
   setPreferredSize(new java.awt.Dimension(iconslotheight, iconslotheight));
   setMaximumSize(new java.awt.Dimension(iconslotheight, iconslotheight));
   setSize(new java.awt.Dimension(iconslotheight, iconslotheight));
   setBackground(java.awt.Color.black);
  }



  public void paint(java.awt.Graphics g)
  {
   try
     {
      int width = getWidth()-framewidth/2;
      int height = getHeight()-framewidth/2;
//      g.setColor(getBackground());
//      g.fillRect(0,0,getWidth(), getHeight());
      java.awt.Point p[] = new java.awt.Point[]
         {
          new java.awt.Point(framewidth/2, framewidth/2),
          new java.awt.Point(width, framewidth/2),
          new java.awt.Point(width, height),
          new java.awt.Point(framewidth/2, height),
          new java.awt.Point(framewidth/2, framewidth/2),
          new java.awt.Point(framewidth/2+5, framewidth/2)
         };
      GraphicHelper.fillSmoothPolyline(p, framewidth, bordercolor, GraphicHelper.getFillColor() , g);
      if(getComponentCount()>0)
        {
         getComponent(0).setBounds(framewidth/2, framewidth/2, iconheight+framewidth/2, iconheight+framewidth/2);
         //getComponent(0).paint(g);
         paintChildren(g);
        }
     }
   catch(Exception e)
     {
      e.printStackTrace(Logger.err);
     }
  };



 public void addIconWidget(IconWidget icon)
 {
  icon.setBounds(getX()+framewidth, getY()+framewidth, iconheight, iconheight);
  super.add(icon);
  icon.setBounds(getX()+framewidth, getY()+framewidth, iconheight, iconheight);
 }


 // ---------------------- ARUIWidgetIF ------------------------
 public IconSlot getFreeIconSlot()
 {
  if(getComponentCount()<1)
     return this;
//  Logger.debug.println("DEBUG[IconSlot] getFreeIconSlot() I'm not free, I have "+getComponentCount()+" sub-components");
  return null;
 }
 public Block getFreeBlock()
 {
  return null;
 }

 public ARWindow getFreeARWindow()
 {
  return null;
 }
 public ARWindow getAnyARWindow()
 {
  return null;
 }

 //--------- externaline and internalize to/from XML------------


 private class MyChainedDocumentHandler extends ChainedDocumentHandler
 {
  public void endElement(String p0) throws SAXException
  {
   super.endElement(p0);
  }

  public void startElement(String p0, AttributeList p1) throws SAXException
  {
   if(getLevel()==0)
     {
      if(!p0.equalsIgnoreCase("IconSlot"))
        throw new SAXException("expected: <IconSlot>, found: <"+p0+">");

     }// ignore deeper levels, that may exist dues to serialization of content that we do not know of yet

   super.startElement(p0, p1);
  }
 }

 public void externalizeToXML(java.io.PrintWriter pw)
 {
  pw.print("<IconSlot>");



  pw.println("</IconSlot>");
 }

 public ChainedDocumentHandler internalizeFromXML()
 {
  return new MyChainedDocumentHandler();
 }
}