package jaugment2.UI.ARUI.xml;

import org.xml.sax.*;

/**
 * Title:        ARUI
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public abstract class ChainedDocumentHandler implements org.xml.sax.DocumentHandler
{

  private org.xml.sax.Parser parser;
  private org.xml.sax.DocumentHandler parent;
  private int level = 0;

  public int getLevel()
  {
   return level;
  }

  public Parser getParser()
  {
   return this.parser;
  }

  /**
   * set the parser, so that it's former DocumentHandler
   * can be restored. Parent may be null.
   */
  public void setParser(org.xml.sax.Parser p, org.xml.sax.DocumentHandler parent)
  {
   this.parser = p;
   this.parent = parent;
  }

  public void characters(char[] p0, int p1, int p2) throws SAXException{};
  public void endDocument() throws SAXException{};
  public void ignorableWhitespace(char[] p0, int p1, int p2) throws SAXException{};
  public void processingInstruction(String p0, String p1) throws SAXException{};
  public void setDocumentLocator(Locator p0){};
  public void startDocument() throws SAXException{};


  public void endElement(String p0) throws SAXException
  {
   level--;

     // this is the last Element, that we handle
   if(level<1)
     {
      if(parent != null)
        parser.setDocumentHandler(parent);
     }
  }

  public void startElement(String p0, AttributeList p1) throws SAXException
  {
   level++;
  }
}